module Yrpc
  module Interceptors
    class Registry

      def initialize
        @interceptors ||= []
      end

      def use(interceptor_class, options = {})
        interceptors_mutex do
          @interceptors << {
              klass: interceptor_class,
              options: options
          }
        end
      end

      #ruby 互斥锁，防止线程对资源进行竞争，导致资源不同步
      def interceptors_mutex(&block)
        @interceptors_mutex ||= begin
          require 'monitor'
          Monitor.new
        end
        @interceptors_mutex.synchronize(&block)
      end
    end
  end
end